#if defined _events_included
  #endinput
#endif
#define _events_included

#define MAX_EVENTS 11
#define ACCESS_CONSOLE 131072

enum event {
    join_game = 0,          // Data[0] is the Userindex
    join_team,          // Data[0] is the Userindex, Data[1] the Teamindex (0 = Spectator, 1 = Terrorist, 2 = CT)
    game_commencing,    // No Data
    game_restart,       // No Data
    round_start,        // No Data
    round_draw,         // Data[0] is the score of T, Data[1] is the score of CT
    round_win,          // Data[0] is the Teamindex of Winning team, Data[1] is the score of T, Data[2] is the score of CT, Data[3] is the Actionstring (e.g. Target_Saved, Terrorists_Win)
    round_end,          // No Data
    injure,             // Data[0] is the Userindex of attacker, Data[1] is the Userindex of victim, Data[2] is the damage inflicted, Data[3] is the armor-damage inflicted, Data[4] is the weaponstring
    kill,               // Data[0] is the Userindex of Attacker, Data[1] is the Userindex of Victim, Data[2] is the weaponstring
    suicide             // Data[0] is the Userindex, Data[1] is the weaponstring (e.g. hegrenade, world)
};

forward register_logd_event(event:Event,Function[]);

stock const g_Function[MAX_EVENTS][] = {
    "logd_reg_joingame",
    "logd_reg_jointeam",
    "logd_reg_commencing",
    "logd_reg_restart",
    "logd_reg_roundstart",
    "logd_reg_rounddraw",
    "logd_reg_roundwin",
    "logd_reg_roundend",
    "logd_reg_injure",
    "logd_reg_kill",
    "logd_reg_suicide"
};

stock register_logd_event(event:Event,Function[]) {
    new Data[3];
    numtostr(Event,Data);
    plugin_registercmd(g_Function[Event],Function,ACCESS_CONSOLE,"");
    new LineData[3];
    new Line;
    while(readfile("addons/adminmod/config/logd_events.ini",LineData,++Line,3)) {
        if(!strcmp(Data,LineData)) return;
    }
    writefile("addons/adminmod/config/logd_events.ini",Data,-1);
}