/*********************************************************
 * A sample plugin - Version 0.8                         *
 *********************************************************
 *                                                       *
 * Name: plugin_rindy_                                   *
 * Author: Rinde (rinde@fiatnox.de)                      *
 * Released: 15/11/02                                    *
 *                                                       *
 *                                                       *
 * Commands:                                             *
 *                                                       *
 * admin_                                                *
 *                                                       *
 * Changelog:                                            *
 *                                                       *
 * Version 0.8                                           *
 *                                                       *
 *  -  Initial release                                   *
 *                                                       *
 *********************************************************/

/* Includes */
#include <plugin>
#include <adminlib>
#include <events>
#include <menu>
#include <checksetting>

#define ACCESS_TK_MENU ACCESS_RESTRICT

#define MENU_NONE 0
#define MENU_FORGIVE 1
#define MENU_FORGIVE_ADMIN 2

/* Global Variables */
new g_Version[] = "0.8";
new g_Punishnextround[MAX_PLAYERS] = {0};
new g_Teamkiller[MAX_PLAYERS] = {0};
new g_Menu[MAX_PLAYERS] = {MENU_NONE};
new g_VisiblePlayers[MAX_PLAYERS][9];
new g_maxplayers;
new g_war;

/* Function Declarations */
forward HandleMS(HLCommand,HLData,HLUserName,UserIndex);
forward HandleKill(HLCommand,HLData,HLUserName,UserIndex);
forward MenuReset(HLCommand,HLData,HLUserName,UserIndex);
forward TKMenu(HLCommand,HLData,HLUserName,UserIndex);
forward ResetRound(HLCommand,HLData,HLUserName,UserIndex);
forward HandleRoundStart(HLCommand,HLData,HLUserName,UserIndex);
forward updatewar();
forward show_menu(UserIndex);

/* Event Handlers */
public plugin_init() {
    plugin_registerinfo("Rinde's TK-Forgive Plugin","A simple menu-based forgive-TK",g_Version);
    new error;
    check_setting(error,"amv_enable_beta",contain,"menu1");
    if(error) {
//        plugin_setdesc("ERROR, see logfiles for details");
        return PLUGIN_CONTINUE;
    }
    register_logd_event(kill,"HandleKill");
    register_logd_event(game_commencing,"ResetRound");
    register_logd_event(game_restart,"ResetRound");
    register_logd_event(round_start,"HandleRoundStart");
    register_menu_reset("MenuReset");
    plugin_registercmd("admin_tkmenu","TKMenu",ACCESS_TK_MENU,"admin_tkmenu: Allows you to forgive anybody hit TK against the victims will.");
    plugin_registercmd("menuselect","HandleMS",ACCESS_ALL);
    g_maxplayers = min(maxplayercount(),32);
    return PLUGIN_CONTINUE;
}

/* Command Handlers */
public HandleKill(HLCommand,HLData,HLUserName,UserIndex) {
    if(g_war) return PLUGIN_CONTINUE;
    static Data[40];
    static UserName[MAX_NAME_LENGTH];
    new AttackerTeam, VictimTeam;
    convert_string(HLData,Data,MAX_DATA_LENGTH);
    if(Data[0] != Data[1] && playerinfo(Data[0],UserName,MAX_NAME_LENGTH,_,_,AttackerTeam) && !access(ACCESS_IMMUNITY,UserName)) {
        if(playerinfo(Data[1],UserName,MAX_NAME_LENGTH,_,_,VictimTeam)) {
            if(AttackerTeam == VictimTeam) {
                g_Punishnextround[Data[0]] += 1;
                g_Teamkiller[Data[1]] = Data[0];
                kill_menu(Data[1]);
                menu(UserName,"\yForgive TK?^n\w1. Yes^n2. No",3,0);
                g_Menu[Data[1]] = MENU_FORGIVE;
            }
        }
    }
    return PLUGIN_CONTINUE;
}

public MenuReset(HLCommand,HLData,HLUserName,UserIndex) {
    if(g_war) return PLUGIN_CONTINUE;
    new Data[2];
    convert_string(HLData,Data,MAX_DATA_LENGTH);
    if(Data[0]) {
        g_Menu[Data[0]] = MENU_NONE;
    } else {
        new i;
        for(i=1;i<=g_maxplayers;i++) {
            g_Menu[i] = MENU_NONE;
        }
    }
    return PLUGIN_CONTINUE;
}

public TKMenu(HLCommand,HLData,HLUserName,UserIndex) {
    if(!UserIndex) {
        selfmessage("This command cannot be used from console.");
        return PLUGIN_CONTINUE;
    }
    if(g_war) {
        selfmessage("Teamkillpunish is disabled during clanwar.");
        return PLUGIN_CONTINUE;
    }
    g_Menu[UserIndex] = MENU_FORGIVE_ADMIN;
    show_menu(UserIndex);
    return PLUGIN_HANDLED;
}

public HandleMS(HLCommand,HLData,HLUserName,UserIndex) {
    if(g_war || g_Menu[UserIndex] == MENU_NONE) return PLUGIN_CONTINUE;
    static Data[MAX_DATA_LENGTH];
    convert_string(HLData,Data,MAX_DATA_LENGTH);
    strstripquotes(Data);
    new i = strtonum(Data);
    g_Menu[UserIndex] = MENU_NONE;
    if(g_Menu[UserIndex] == MENU_FORGIVE) {
        if(i == 1) {
            if(g_Punishnextround[g_Teamkiller[UserIndex]]) {
                static UserName1[MAX_NAME_LENGTH],UserName2[MAX_NAME_LENGTH];
                g_Punishnextround[g_Teamkiller[UserIndex]] -= 1;
                convert_string(HLUserName,UserName1,MAX_NAME_LENGTH);
                playerinfo(g_Teamkiller[UserIndex],UserName2,MAX_NAME_LENGTH);
                snprintf(Data,MAX_DATA_LENGTH,"%s forgave %s his teamkill.",UserName1,UserName2);
                say(Data);
            }
            g_Teamkiller[UserIndex] = 0;
            return PLUGIN_HANDLED;
        } else if(i == 2) {
            return PLUGIN_HANDLED;
        }
    } else {
        if(i) {
            new k,j = g_VisiblePlayers[UserIndex][i-1];
            if(j && g_Punishnextround[j]) {
                static UserName[MAX_NAME_LENGTH];
                playerinfo(j,UserName,MAX_NAME_LENGTH);
                snprintf(Data,MAX_DATA_LENGTH,"An admin forgave %s his teamkills.",UserName);
                say(Data);
                convert_string(HLUserName,UserName,MAX_NAME_LENGTH);
                snprintf(Data,MAX_DATA_LENGTH,"%s forgave someone his teamkills.",UserName);
                log(Data);
                for(i=1;i<=g_maxplayers,g_Punishnextround[j];i++) {
                    if(g_Teamkiller[i] == j) {
                        g_Teamkiller[i] = 0;
                        if(g_Menu[i] == MENU_FORGIVE) {
                            clear_menu(i);
                            g_Menu[i] = MENU_NONE;
                        }
                        k++;
                        if(k == g_Punishnextround[j]) break;
                    }
                }
                g_Punishnextround[j] = 0;
            }
        } else {
            return PLUGIN_HANDLED;
        }
    }
    return PLUGIN_CONTINUE;
}

public ResetRound(HLCommand,HLData,HLUserName,UserIndex) {
    if(g_war) return PLUGIN_CONTINUE;
    new i;
    for(i=0;i<=g_maxplayers;i++) {
        g_Punishnextround[i] = 0;
        g_Teamkiller[i] = 0;
        if(g_Menu[i] != MENU_NONE) {
            clear_menu(i);
            g_Menu[i] = MENU_NONE;
        }
    }
    return PLUGIN_CONTINUE;
}

public HandleRoundStart(HLCommand,HLData,HLUserName,UserIndex) {
    updatewar();
    if(g_war) return PLUGIN_CONTINUE;
    new i;
    for(i=0;i<=g_maxplayers;i++) {
        if(g_Menu[i] != MENU_NONE) {
            clear_menu(i);
            g_Menu[i] = MENU_NONE;
        }
        g_Teamkiller[i] = 0;
        if(g_Punishnextround[i]) {
            static UserName[MAX_NAME_LENGTH];
            g_Punishnextround[i] = 0;
            if(playerinfo(i,UserName,MAX_NAME_LENGTH)) {
                setstrvar("admin_fx","0");
                slay(UserName);
                setstrvar("admin_fx","1");
            }
        }
    }
    return PLUGIN_CONTINUE;
}

public plugin_disconnect(HLUserName,UserIndex) {
    if(g_war) return PLUGIN_CONTINUE;
    if(g_Teamkiller[UserIndex]) {
        g_Punishnextround[g_Teamkiller[UserIndex]] -= 1;
        g_Teamkiller[UserIndex] = 0;
    }
    if(g_Punishnextround[UserIndex]) {
        g_Punishnextround[UserIndex] = 0;
        new i;
        for(i=1;i<=g_maxplayers;i++) {
            if(g_Teamkiller[i] == UserIndex && g_Menu[i] == MENU_FORGIVE) {
                clear_menu(i);
                g_Menu[i] = MENU_NONE;
            }
        }
    }
    g_Menu[UserIndex] = MENU_NONE;
    return PLUGIN_CONTINUE;
}

updatewar() {
    static value[10];
    get_serverinfo("war",value,10);
    g_war = check_param(value);
}

show_menu(UserIndex) {
    new Menutext[512] = "\yForce forgive TK\w^n";
    new UserName[MAX_NAME_LENGTH];
    new Text[MAX_NAME_LENGTH + 9];
    new Keys;
    new i,j;
    for(i=1;i<=g_maxplayers;i++) {
        if(g_Punishnextround[i]) {
            if(playerinfo(i,UserName,MAX_NAME_LENGTH)) {
                g_VisiblePlayers[UserIndex][j] = i;
                j++;
                snprintf(Text,MAX_NAME_LENGTH + 9,"^n%i. %s (%i)",j,UserName,g_Punishnextround[i]);
                strcat(Menutext,Text,512);
                if(j == 9) break;
            }
        }
    }
    Keys = (1<<j) + 511;
    for( ;j<9;j++)
        g_VisiblePlayers[UserIndex][j] = 0;
    strcat(Menutext,"^n^n0. Exit",512);
    playerinfo(UserIndex,UserName,MAX_NAME_LENGTH);
    menu(UserName,Menutext,Keys,0);
}